# ydl_ai_recommender

## 简介

根据用户的画像信息，推荐咨询师


## 使用

无特殊说明，下面所有的操作均在项目主目录（也就是本文件所在目录）下操作


### 环境配置


```bash
# 第一次配置，构建虚拟环境
conda env create --file environment.yaml

```

**之后每次使用时，先进入虚拟环境 `source activate yar`**


### 更新特征、索引信息

```bash

# 1. 从数据库中拉取最新数据到本地
python bin/update.py -t load_db_data

# 2. 构建用户向量
python bin/update.py -t make_embedding

# 3. 构建相关索引
python bin/update.py -t make_index

```

### 启动接口服务

```bash
# 一定要在 `bin` 目录中执行
cd bin
sh start_a.sh
```

### 更新模型

为了保证线上服务的稳定性，使用nginx做负载均衡，在更新模型接口时，需要先启动新的服务，验证无问题后结束原有的服务。
由于线上只有一台服务器，因此将服务端口设置为 A/B 两组，若当前服务是A组的，则启动B组，验证B组服务无问题，关闭A组服务，具体的执行操作如下：

```
# bin 目录中
# 启动服务，启动后相关接口服务的pid会记录在 `start_service_version_b.pid` 文件中
./start_b.sh

# 关闭A组服务，根据启动时保存的pid，kill掉，结束后会将保存pid的文件删除
./stop_a.sh

# 也可查看相关进程服务情况
ps aux | grep recommend_service
```


### 性能测试

```bash
python bin/test.py

# 更多相关操作，使用 --help 查看
# 相关细节见代码注释
```


## 项目目录介绍

 - `analysis` 前期调研、新方法评估试验等相关脚本存放目录
 - `bin` 相关执行脚本目录
 - `data` 项目中用到的数据存放目录
 - `log` 项目内接口、脚本等运行日志存放目录
 - `src` 项目核心代码目录
   - `core` 核心代码
   - `data` 数据操作相关代码
   - `service` 推荐算法接口服务
   - `utils` 公共用到的工具类